// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "MenuBarApp.h"

#include "MainFrm.h"
#include "SkinMenu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()
	ON_WM_MEASUREITEM()
	ON_WM_NCCALCSIZE()
	ON_WM_NCPAINT() 
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	
	
	
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_wndReBar.Create(this,RBS_AUTOSIZE,WS_CHILD | WS_VISIBLE | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | CBRS_TOP );
	m_wndMenuBar.Create(IDD_DIALOGBAR,this);
	m_wndReBar.AddBar(&m_wndMenuBar,0,0,RBBS_HIDDEN );
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);

	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	


	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	//cs.style &= WS_CAPTION ; 

	if (cs.hMenu != NULL) 
	{	
		::DestroyMenu(cs.hMenu) ; 
		cs.hMenu = NULL ; 
		
	}
	
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}
BOOL CMainFrame::LoadFrame(UINT nIDResource,DWORD dwDefaultStyle,CWnd* pParentWnd,CCreateContext* pContext)
{

	return CMDIFrameWnd::LoadFrame(nIDResource,dwDefaultStyle,pParentWnd, NULL) ; 
	//return CFrameWnd::LoadFrame(nIDResource,dwDefaultStyle,pParentWnd,pContext);

}
BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	return CreateClient(lpcs,NULL);

}



void CMainFrame::OnNcCalcSize(BOOL bCalcValidRects,NCCALCSIZE_PARAMS *lpncsp) 
{

	CRect rectClient = lpncsp->rgrc[0] ; 
	rectClient.DeflateRect(0,20);
	//rectClient.DeflateRect(m_nBorder,m_nBorder);
	//lpncsp->rgrc[0] = rectClient ;
	CMDIFrameWnd::OnNcCalcSize(bCalcValidRects,lpncsp) ; 

}

void CMainFrame::OnNcPaint() 
{

	CMDIFrameWnd::OnNcPaint(); 
	
	
	CWindowDC dc(this) ; 
	CRect rcWindow; 
	GetWindowRect(&rcWindow) ;

	rcWindow.OffsetRect(-rcWindow.TopLeft()) ; 

	//DrawCaption(&dc,&rcWindow,DC_ICON |  DC_TEXT | DC_BUTTONS) ; 
	//DrawMenuBar() ; 

}

// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

void CMainFrame::OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct)
{
	//if ( lpMeasureItemStruct->itemID == ID_HELLO || lpMeasureItemStruct->itemID == ID_WORLD)
 //        //lpMeasureItemStruct->itemID == (UINT)m_hMenuSub )
 //   {
	//	CSkinMenu *pMenu = (CSkinMenu*) GetMenu();
	//	pMenu->MeasureItem(lpMeasureItemStruct);
 //   }
 //   else
 //       // let MFC's self-drawing handle it
        CMDIFrameWnd::OnMeasureItem(nIDCtl, lpMeasureItemStruct);
}

// CMainFrame message handlers



